#include <bits/stdc++.h>
using namespace std;   
typedef unsigned long long ull;


int main()
{
    int n,m; cin >> n >> m;
    vector<int> d(n),u(n);
    for(int i=0; i<n; i++) cin >> d[i] >> u[i];

    for(int i=0; i<m; i++){
        int sol=0;
        int l,r,x; cin >> l >> r >> x;
        l--;r--;
        for(int j=l; j<=r; j++){
            if(d[j]<=x && x<=u[j])sol++;
        }
        cout << "!" << sol << '\n';
    }
    return 0;
}